<template>
  <div class="content-grid content-grid--subpage">
    <Breadcrumbs :title="mesRoutes"/>
    <BackLinkTitle :title="backLinkTitle"/>
    <Card title="Grilles">
      <DataTable
          :headers="grillesHeader"
          :items="tableGrilles"
          @external="imporationGrilleHandler"
          @click="handleRowClick"
      />
    </Card>
  </div>
  <el-dialog
      v-if="grilleChoisi"
      v-model="imporationGrilleDialog"
      title="Importation d'une grille"
      width="500"
      center
  >
    <span>
      Vous pouvez importer une grille en remplissant les champs ci-dessous
    </span>
    <template #footer>
      <div class="dialog-footer">
        <form
            class="form"
            novalidate
            @submit.prevent="imporationGrilleHandleSubmit"
            enctype="multipart/form-data"
        >
          <Fieldset>
            <FormRow>
              <FormInput
                  v-model="grilleChoisi.titre"
                  type="text"
                  name="Titre"
                  ref="addFormInputRef"
                  @validated="handleValidation"
              />
              <FormInput
                  v-model="grilleChoisi.ponderation"
                  type="number"
                  name="Ponderation"
                  ref="addFormInputRef"
                  @validated="handleValidation"
              />
            </FormRow>
          </Fieldset>
          <button class="form__submit btn btn--fullscreen" type="submit">
            {{ t("global.actions.external") }}
          </button>
        </form>
      </div>
    </template>
  </el-dialog>
</template>

<script lang="ts" setup>
//#region Imports
import Card from "@/components/layout/Card.vue";
import {useI18n} from "vue3-i18n";
import DataTable from "@/components/layout/DataTable.vue";
import {useGrilleService, useCoursService} from "@/inversify.config";
import {useRoute, useRouter} from "vue-router";
import Breadcrumbs from "@/components/layout/Breadcrumbs.vue";
import {ref, onMounted, computed} from "vue";
import {notifyError, notifySuccess} from "@/notify";
import BackLinkTitle from "@/components/layout/BackLinkTitle.vue";
import {Grille} from "@/types/entities/grille";
import FormRow from "@/components/forms/FormRow.vue";
import FormInput from "@/components/forms/FormInput.vue";
import {Cours} from "@/types/entities/cours";
import {Status} from "@/validation";
import {ICreateGrilleRequest} from "@/types/requests/createGrilleRequest";
import {ICopyGrilleRequest} from "@/types/requests/copyGrilleRequest";
//#endregion

//#region Variables
const mesRoutes =
    "Cours / Consultation des cours / Details du cours / Importer grille";
const backLinkTitle = "Importer grille";
const imporationGrilleDialog = ref(false);
const {t} = useI18n();
const route = useRoute();
const grilleService = useGrilleService();
const coursService = useCoursService();
const formInputs = ref<any[]>([]);
const inputValidationStatuses: any = {};
const router = useRouter();
const coursId = route.params.id.toString();
const cours = ref<Cours>(await coursService.getCours(coursId));
const grilles = ref<Grille[]>([]);
const grilleChoisi = ref({
  id: "",
  titre: "",
  ponderation: 0,
  coursId: cours.value.id,
  element: [],
});
const tableGrilles = computed(() => {
  return grilles.value
      .map((x: any) => {
        return {
          id: x.id,
          titre: x.titre,
          ponderation: x.ponderation,
          cours: x.cours.nomCours,
          element: x.element,
          actions: {
            external: true,
          },
        };
      })
      .sort((a: any, b: any) => {
        if (a.name < b.name) {
          return -1;
        }
        if (a.name > b.name) {
          return 1;
        }
        return 0;
      }) as any[];
});
//#endregion

//#region Methods
onMounted(async () => {
  grilles.value = await grilleService.getAllGrilles();
});

const handleRowClick = (e: any) => {
  if (e !== undefined)
    e.target.parentNode.getElementsByTagName('button')[0].click()
}

function imporationGrilleHandler(grille: any) {
  imporationGrilleDialog.value = true;
  grilleChoisi.value = grille;
}

async function handleValidation(name: string, validationStatus: Status) {
  inputValidationStatuses[name] = validationStatus.valid;
}

function addFormInputRef(ref: typeof FormInput) {
  if (!formInputs.value.includes(ref) && ref) formInputs.value.push(ref);
}

async function imporationGrilleHandleSubmit() {
  if (grilleChoisi.value) {
    grilleChoisi.value.coursId = cours.value.id;
    let succeededOrNotResponse = await grilleService.copyGrille(
        {
          grilleId: grilleChoisi.value.id,
          coursId: cours.value.id,
          titre: grilleChoisi.value.titre,
          ponderation: grilleChoisi.value.ponderation
        } as ICopyGrilleRequest
    );
    if (succeededOrNotResponse && succeededOrNotResponse.succeeded) {
      notifySuccess(t("validation.grille.importation.success"));
      setTimeout(() => {
        router.back();
      }, 1500);
    } else {
      let errorMessages = succeededOrNotResponse.getErrorMessages(
          "validation.grille.importation.errorOccured"
      );
      if (errorMessages.length == 0)
        notifyError(t("validation.grille.importation.errorOccured"));
      else notifyError(errorMessages[0]);
    }
  }
}

//#endregion

//#region Headers
const grillesHeader = [
  {
    text: "Titre",
    value: "titre",
    sortable: true,
    width: 150,
  },
  {
    text: "Ponderation(%)",
    value: "ponderation",
    sortable: true,
    width: 100,
  },
  {
    text: "Nom du cours",
    value: "cours",
    sortable: true,
    width: 100,
  },
  {
    text: "",
    value: "actions",
    width: 120,
  },
];
//#endregion
</script>
